/* arg_parser.c generated by valac 0.56.17, the Vala compiler
 * generated from arg_parser.vala, do not modify */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ARG_PARSER (arg_parser_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

/**
 * A lazy/minimal command-line arg parser because OptionContext segfaults.
 */
typedef enum  {
	ARG_PARSER_PARSE_ERROR
} ArgParser;
#define ARG_PARSER arg_parser_quark ()

VALA_EXTERN GQuark arg_parser_quark (void);
VALA_EXTERN GType arg_parser_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeMap* parse_args (gchar** args,
                    gint args_length1,
                    GError** error);
VALA_EXTERN gboolean isKey (const gchar* inval);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
arg_parser_quark (void)
{
	return g_quark_from_static_string ("arg-parser-quark");
}

static GType
arg_parser_get_type_once (void)
{
	static const GEnumValue values[] = {{ARG_PARSER_PARSE_ERROR, "ARG_PARSER_PARSE_ERROR", "parse-error"}, {0, NULL, NULL}};
	GType arg_parser_type_id;
	arg_parser_type_id = g_enum_register_static ("ArgParser", values);
	return arg_parser_type_id;
}

GType
arg_parser_get_type (void)
{
	static volatile gsize arg_parser_type_id__once = 0;
	if (g_once_init_enter (&arg_parser_type_id__once)) {
		GType arg_parser_type_id;
		arg_parser_type_id = arg_parser_get_type_once ();
		g_once_init_leave (&arg_parser_type_id__once, arg_parser_type_id);
	}
	return arg_parser_type_id__once;
}

/**
 * Convert ["-v", "-s", "asdf", "-f", "qwe"] => {("-v", null), ("-s", "adsf"), ("-f", "qwe")} 
 * Populates key of "cmd" with first arg.
 * NOTE: Currently does not support quoted parameter values.
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

GeeMap*
parse_args (gchar** args,
            gint args_length1,
            GError** error)
{
	GeeHashMap* argMap = NULL;
	GeeHashMap* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gchar* lastKey = NULL;
	const gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	GeeMap* result;
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	argMap = _tmp0_;
	if (args == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = args_length1 == 0;
	}
	if (_tmp1_) {
		result = (GeeMap*) argMap;
		return result;
	}
	lastKey = NULL;
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
		token_collection = args;
		token_collection_length1 = args_length1;
		for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
			gchar* _tmp2_;
			gchar* token = NULL;
			_tmp2_ = g_strdup (token_collection[token_it]);
			token = _tmp2_;
			{
				GeeHashMap* _tmp3_;
				_tmp3_ = argMap;
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, "cmd")) {
					GeeHashMap* _tmp4_;
					const gchar* _tmp5_;
					_tmp4_ = argMap;
					_tmp5_ = token;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "cmd", _tmp5_);
				} else {
					const gchar* _tmp6_;
					_tmp6_ = token;
					if (isKey (_tmp6_)) {
						const gchar* _tmp7_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						_tmp7_ = lastKey;
						if (_tmp7_ != NULL) {
							GeeHashMap* _tmp8_;
							const gchar* _tmp9_;
							_tmp8_ = argMap;
							_tmp9_ = lastKey;
							gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp9_, NULL);
						}
						_tmp10_ = token;
						_tmp11_ = g_strdup (_tmp10_);
						_g_free0 (lastKey);
						lastKey = _tmp11_;
					} else {
						const gchar* _tmp12_;
						_tmp12_ = lastKey;
						if (_tmp12_ != NULL) {
							GeeHashMap* _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
							_tmp13_ = argMap;
							_tmp14_ = lastKey;
							_tmp15_ = token;
							gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
							_g_free0 (lastKey);
							lastKey = NULL;
						} else {
							const gchar* _tmp16_;
							const gchar* _tmp17_;
							gchar* _tmp18_;
							gchar* _tmp19_;
							GError* _tmp20_;
							GError* _tmp21_;
							_tmp16_ = token;
							_tmp17_ = string_to_string (_tmp16_);
							_tmp18_ = g_strconcat ("Unexpected literal: ", _tmp17_, "\n", NULL);
							_tmp19_ = _tmp18_;
							_tmp20_ = g_error_new_literal (ARG_PARSER, ARG_PARSER_PARSE_ERROR, _tmp19_);
							_tmp21_ = _tmp20_;
							_g_free0 (_tmp19_);
							_inner_error0_ = _tmp21_;
							if (_inner_error0_->domain == ARG_PARSER) {
								g_propagate_error (error, _inner_error0_);
								_g_free0 (token);
								_g_free0 (lastKey);
								_g_object_unref0 (argMap);
								return NULL;
							} else {
								_g_free0 (token);
								_g_free0 (lastKey);
								_g_object_unref0 (argMap);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
					}
				}
				_g_free0 (token);
			}
		}
	}
	_tmp22_ = lastKey;
	if (_tmp22_ != NULL) {
		GeeHashMap* _tmp23_;
		const gchar* _tmp24_;
		_tmp23_ = argMap;
		_tmp24_ = lastKey;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp24_, NULL);
	}
	result = (GeeMap*) argMap;
	_g_free0 (lastKey);
	return result;
}

gboolean
isKey (const gchar* inval)
{
	gboolean result;
	g_return_val_if_fail (inval != NULL, FALSE);
	result = g_str_has_prefix (inval, "-");
	return result;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

